/* 
	PackageObject.java
	Jason C. Judt
	This file was writen for the ICFP 2002 contest and may be used by anyone, anywhere
	without restriction. Enjoy. 
*/

package myprojects.jbotchallenge;

import java.util.*;

public class PackageObject extends Object
{

	public static final int OWNED_STATE 	= 0;
	public static final int DROPPED_STATE 	= 1;
	public static final int UNKNOWN_STATE 	= 2;
	public static final int FUTILE_STATE	= 3;

	public PackageObject(int id, int destX, int destY, int weight)
	{
		m_ID = id;
		m_DestinationX = destX;
		m_DestinationY = destY;
		m_Weight = weight;
		m_State = UNKNOWN_STATE;	
	}
	
	public PackageObject(int id)
	{
		m_ID = id;
		m_DestinationX = -1;
		m_DestinationY = -1;
		m_Weight = -1;
		m_State = UNKNOWN_STATE;	
	}
	
	public void setLocation(int x, int y)
	{
		m_LocationX = x;
		m_LocationY = y;	
	}
	
	public int getID()
	{
		return m_ID;
	}
	
	public int getLocationX()
	{
		return m_LocationX;
	}
	
	public int getLocationY()
	{
		return m_LocationY;
	}
	
	public void setDestination(int x, int y)
	{
		m_DestinationX = x;
		m_DestinationY = y;	
	}
	
	public int getDestinationX()
	{
		return m_DestinationX;
	}
	
	public int getDestinationY()
	{
		return m_DestinationY;
	}
	 
	public void setWeight(int w)
	{
		m_Weight = w;	
	}
	
	public int getWeight()
	{
		return m_Weight;	
	}
	
	public void setState(int w)
	{
		m_State = w;	
	}
	
	public int getState()
	{
		return m_State;	
	}
	
	public double getWeightDistanceValue()
	{
		int distance = getShortestDistance(this, this.getDestinationX(), this.getDestinationY());
		return (double) ((double)distance / (double)m_Weight); 		
	}
	
	public double getWeightDistanceValue(int newLocationX, int newLocationY)
	{
		setLocation(newLocationX, newLocationY);
		return getWeightDistanceValue();
	}
	
	public static int getShortestDistance(PackageObject po, int x, int y)
	{
		if ((po.m_LocationX == -1) || (po.m_LocationY == -1)) return -1;
		
		int absoluteX;
		int absoluteY;
		int distance;
		
		if (x > po.m_LocationX)
			absoluteX = x - po.m_LocationX;
		else
			absoluteX = po.m_LocationX - x;
		
		if (y > po.m_LocationY)
			absoluteY = y - po.m_LocationY;
		else 
			absoluteY = po.m_LocationY - y;
				
		distance = absoluteX + absoluteY;
		
		return distance;
	}
	
	
	private int 	m_ID;
	private int 	m_DestinationX;
	private int 	m_DestinationY;
	private int 	m_LocationX;
	private int 	m_LocationY;
	private int 	m_Weight;
	private int		m_State;
	
	// for later
	private Vector 	m_Paths;
		
}