/* 
	SimpleEvadingBotFunction.java
	Jason C. Judt
	This file was writen for the ICFP 2002 contest and may be used by anyone, anywhere
	without restriction. Enjoy. 
*/

package myprojects.jbotchallenge;

import java.awt.Point;
import java.util.*;
import myprojects.jbotchallenge.BotFunction;

public class SimpleEvadingBotFunction extends BotFunction
{
	public SimpleEvadingBotFunction(GameGrid gg, BotInterface bot)
	{
		super(gg, bot);	
//		m_NoPackagesCollection = new Vector();	
		m_BidDefault = "1";
		m_PathToDestination = null;
		m_RecalcDestination = false;
	}
	
	public String calcNextMove()
	{
		int i = 0;
		System.out.println("OurBot<Evading> choosing action");
		m_NextActionString = null;
		
		// first, we got signaled because someone came within two hops of us
		// let's find them and the path to them
		Vector closeRobots = m_gg.getRobotsWithinTwoStepsOfPoint(m_bot.getLocationX(), m_bot.getLocationY());
		
		// avoid at all costs
		boolean closeToWater = false;
		// can we go north south east or west?
		boolean canGoNorth = true;
		boolean canGoSouth = true;
		boolean canGoEast = true;
		boolean canGoWest = true;
		
		// first, check if we are on perimeter
		if (m_bot.getLocationX() == 0) canGoWest = false;
		if (m_bot.getLocationX() == (m_gg.getColCount())) canGoEast = false;
		if (m_bot.getLocationY() == 0) canGoSouth = false;
		if (m_bot.getLocationY() == (m_gg.getRowCount())) canGoNorth = false;
		
		for (i=0; i<closeRobots.size(); i++)
		{
			Robot r = (Robot) closeRobots.get(i);
			if (r.getLocationY() > m_bot.getLocationY()) canGoNorth = false;
			if (r.getLocationY() < m_bot.getLocationY()) canGoSouth = false;
			if (r.getLocationX() > m_bot.getLocationX()) canGoEast = false;
			if (r.getLocationX() < m_bot.getLocationX()) canGoWest = false;
		}
/*
		if ((canGoNorth) && 
			(m_gg.getCellTypeAt(m_bot.getLocationX(), m_bot.getLocationY() + 1) != GameGrid.OPEN_SPACE))
		{
			if (m_gg.getCellTypeAt(m_bot.getLocationX(), m_bot.getLocationY() + 1) != GameGrid.WATER)
				closeToWater = true;
			canGoNorth = false;
		}
		if ((canGoEast) &&
			(m_gg.getCellTypeAt(m_bot.getLocationX() + 1, m_bot.getLocationY()) != GameGrid.OPEN_SPACE))
		{
			if (m_gg.getCellTypeAt(m_bot.getLocationX() + 1, m_bot.getLocationY()) != GameGrid.WATER)
				closeToWater = true;
			canGoEast = false;
		}
		if ((canGoSouth) &&
			(m_gg.getCellTypeAt(m_bot.getLocationX(), m_bot.getLocationY() - 1) != GameGrid.OPEN_SPACE))
		{
			if (m_gg.getCellTypeAt(m_bot.getLocationX(), m_bot.getLocationY() - 1) != GameGrid.WATER)
				closeToWater = true;
			canGoSouth = false;
		}	
		if ((canGoWest) && 
			(m_gg.getCellTypeAt(m_bot.getLocationX() - 1, m_bot.getLocationY()) != GameGrid.OPEN_SPACE))
		{
			if (m_gg.getCellTypeAt(m_bot.getLocationX() - 1, m_bot.getLocationY()) != GameGrid.WATER)
				closeToWater = true;
			canGoWest = false; 	
		}
*/			
		// how many options have we?
		int numberOfOptions = 0;
		if (canGoNorth) numberOfOptions++;
		if (canGoNorth) numberOfOptions++;
		if (canGoNorth) numberOfOptions++;
		if (canGoNorth) numberOfOptions++;
		
		if (numberOfOptions == 0)
		{
			// pick non fatal direction and ram our way through
			// if we aren't close to water
			System.out.println("OurBot<Evading> No options...full speed ahead!");
			String bid = null;
			if (closeToWater) bid = Integer.toString(m_bot.getMoney()/10 + 1);
			else bid = Integer.toString(m_bot.getMoney()/5 + 1);
			m_NextActionString = bid + " Move " + m_gg.pickSafeDirection(m_bot.getLocationX(), m_bot.getLocationY());
		}
		if (numberOfOptions == 1)
		{
			// take the only way out
			System.out.println("OurBot<Evading> One option...full speed ahead!");
			String bid = null;
			String direction = null;
			if (canGoNorth) direction = "N";
			if (canGoSouth) direction = "S";
			if (canGoEast) direction = "E";
			if (canGoWest) direction = "W";
			
			if (closeToWater) bid = Integer.toString(m_bot.getMoney()/10 + 1);
			else bid = Integer.toString(m_bot.getMoney()/5 + 1);
			m_NextActionString = bid + " Move " + direction;

		}
		if ((numberOfOptions == 2) || (numberOfOptions == 3) || (numberOfOptions == 4))
		{
			System.out.println("OurBot<Evading> A few options...where to go?");
			String bid = null;
			String direction = null;
			String calcedPath = m_bot.getCurrentPath();
			String intendedDirection = null;
			
			// let's see which way is to our advantage
			if (calcedPath != null)
			{
				StringTokenizer st = new StringTokenizer(calcedPath, " ");
				// which way do we want to go?
				intendedDirection = st.nextToken();
			} 
			else
			{  
				intendedDirection = m_gg.pickSafeDirection(m_bot.getLocationX(), m_bot.getLocationY());
			}
			
			if ((intendedDirection.equals("N")) && (canGoNorth)) direction = "N";
			if ((intendedDirection.equals("S")) && (canGoNorth)) direction = "S";
			if ((intendedDirection.equals("E")) && (canGoNorth)) direction = "E";
			if ((intendedDirection.equals("W")) && (canGoNorth)) direction = "W";
			
			if (direction != null)
			{
				System.out.println("OurBot<Evading> Going the way we wanted to...");
				// modify current path
				if ((m_bot.getCurrentPath() != null) && (m_bot.getCurrentPath().length() > 2))
					m_bot.setCurrentPath(m_bot.getCurrentPath().substring(2));
				else 
					m_bot.setCurrentPath(null);	
			}
			else
			{
				System.out.println("OurBot<Evading> Going off the path a little...");
				if ((intendedDirection.equals("N")) && (canGoEast)) direction = "E";
				if ((intendedDirection.equals("N")) && (canGoWest)) direction = "W";
				if ((intendedDirection.equals("S")) && (canGoEast)) direction = "E";
				if ((intendedDirection.equals("S")) && (canGoWest)) direction = "W";
				if ((intendedDirection.equals("E")) && (canGoNorth)) direction = "N";
				if ((intendedDirection.equals("E")) && (canGoSouth)) direction = "S";
				if ((intendedDirection.equals("W")) && (canGoNorth)) direction = "N";
				if ((intendedDirection.equals("W")) && (canGoSouth)) direction = "S";
			}
			if (closeToWater) 
				bid = Integer.toString((m_bot.getMoney()/10) + 1);
			else 
				bid = Integer.toString((m_bot.getMoney()/50) + 1);
		
		
			m_NextActionString = bid + " Move " + direction;
		}
		
		
		if (m_NextActionString == null)
		{
			int jj = 0;
		}		
		return m_NextActionString;
	}
	
	protected String choosePackages()
	{
		// don't need to worry about this one
		return null;
	}
	
	protected String calculatePath()
	{
		return null;
	}
	
	protected String determineBid()
	{
		// have to mess with this
		return m_BidDefault;
	}
	
	private String popNextPathSegment()
	{
		String segment = null;
//		System.out.println("OurBot<Delivery> old path is: " + m_PathToDestination);
		if (m_PathToDestination.length() <= 2)
		{
			segment = m_PathToDestination;
			m_PathToDestination = null;
			return segment;
		}	
		segment = m_PathToDestination.substring(0, 1);
		System.out.println("OurBot<Delivery> will move " + segment);
		m_PathToDestination = m_PathToDestination.substring(2);
//		System.out.println("OurBot<Delivery> future path is: " + m_PathToDestination);
		return segment;	
	}
	
	protected void cleanUp()
	{
		// reset so this state can be run again in a new context
		m_PathToDestination = null;
		m_NextActionString = null;
		m_RecalcDestination = false;
	}
		

//	private Vector m_NoPackagesCollection;	// vector of points where we have been that have no packages
	private String 	m_PathToDestination;
	private String 	m_NextActionString;
	private String 	m_BidDefault;
	private boolean m_RecalcDestination;
}